/*======================================================================*\
|| #################################################################### ||
|| # Copyright ©2006-2012 Youjoomla.com. All Rights Reserved.           ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------- THIS IS NOT FREE SOFTWARE ---------------- #      ||
|| # http:www.youjoomla.com | http:www.youjoomla.com/license.html # ||
|| #################################################################### ||
\*======================================================================*/
/**
 * YJ Live Search
 * @version		2.0.1
 * @jQuery
 * @Copyright Youjoomla.com
 * @License commercial
 */
// the semi-colon before function invocation is a safety net against concatenated
// scripts and/or other plugins which may not be closed properly.
;(function ( $, window, document, undefined ) {


		var pluginName = "YJLiveSearch",
				defaults = {
				inputId: 'LiveSearch',
				inputCopy:'',
				resultFeed:'search.php',
				noResultsMessage:'',
				topDistance: 25,
				duration: 200,
				minLenght: 3,
				maxLenght: 8,
				minCharTxt1:'Minimum',
				minCharTxt2:'characters required'
		};

		// The actual plugin constructor
		function Plugin ( element, options ) {
				this.element = element;

				this.settings = $.extend( {}, defaults, options );
				this._defaults = defaults;
				this._name = pluginName;
				
				
				this.start();
		}

		// Avoid Plugin.prototype conflicts
		$.extend(Plugin.prototype, {
			
				
				start: function(){
					
					
					self = this;
					
					
						$(self.settings.inputId).addClass('LiveSearchStop').attr({'autocomplete':'off'});		
						this.currentPage = 1;		
						/*results div*/
						this.searchResultsContainer = $('div',{
							'class':'LiveSearchContainer'+self.settings.inputCopy,
							css:{
								'top':-1000,
								'left':-1000,
								'display':'block'
							}
						}).append(document.body);	
						this.header = $('div',{
							'class':'LiveSearchHeader'
						}).append(this.searchResultsContainer);		
						
						this.searchResults = $('div', {
							'class':'LiveSearchResults'+self.settings.inputCopy
						}).append(this.searchResultsContainer);		
						
						this.fadeSearch = new Fx.Morph(this.searchResults, {
							duration:self.settings.duration, 
							wait:false,
							link:'cancel'
						});		
						/*input event*/
						//$(self.settings.inputId).addEvent('keyup', this.request.bind(this));
				
						// lets count chars and than run ajax
				
						$(self.settings.inputId).on('keyup', function(event){
						  if( ($(self.settings.inputId).value.length > self.settings.minLenght || ($(self.settings.inputId).value.length == self.settings.minLenght)) && $(self.settings.inputId).value.length < self.settings.maxLenght){
							  this.request(true);
						  }else if($(self.settings.inputId).value.length < self.settings.minLenght){
									var noresults1 = $$('.noResults.showresults');
									var noresults2 = $$('.noResults.minchars');
									if(noresults2.length  == 0){
									new Element('div',{
										'class':'noResults minchars',
										'html':self.settings.minCharTxt1 + self.settings.minLenght + self.settings.minCharTxt2
									}).inject(this.searchResults);
									}
									noresults1.dispose();
									this.toggleSearch(true);
									
						  }
						}.bind(this));			
						/*clear result on input click*/		
						$(self.settings.inputId).on('click', function(event){	
							this.toggleSearch(false);			
						}.bind(this));			
						/*clear results on body click*/		
						$(document.body).on('click', function(event){
							this.toggleSearch(false);			
						}.bind(this));		
					},
					
					request: function(){
						$(self.settings.inputId).removeClass('LiveSearchStop');
						$(self.settings.inputId).addClass('LiveSearchLoading');
						var request = new Request.JSON({
							url: this.createURL(),						   
							onSuccess: function(jsonObj) {
								$(self.settings.inputId).addClass('LiveSearchStop');
								this.searchResults.empty();
								this.JsonResponse = new Hash(jsonObj.results);
								
							//	console.log();
							
						
								if(this.JsonResponse.getLength() == 0){
									new Element('div',{
										'class':'noResults showresults',
										'html':self.settings.noResultsMessage+$(self.settings.inputId).value
									}).inject(this.searchResults);
								}else{
									this.addResults();
								};					
								this.toggleSearch( true );				
								if(jsonObj.pages > 1){
									this.setNavigation(jsonObj.pages);
								}				
							}.bind(this)
						}).get();		
					},
					
					addResults: function(){
						
						
						
						self = this;
						
						this.JsonResponse.each(function(elem){
							var resultContainer = new Element('div',{
								'class':'LiveSearchResult'
							});
							var mainAnchor = new Element('a',{
								'href':elem.url,
								'html':elem.title
							});
							var expandAnchor = new Element('a',{
								'href':'#',
								'class':'LiveSearchExpandDetails'
							});
							var details = new Element('div',{
								'class':'LiveSearchExpander',
								'html':elem.description,
								'styles':{
									'display':'none',
									'opacity':0
								}
							});
							var images = new Element('div',{
								'class':'LiveSearchImg',
								'html':elem.image
							});
							resultContainer.adopt(mainAnchor,expandAnchor,details).inject(this.searchResults);
							details.grab(images,'top');					
							
							var effect = new Fx.Morph(details, {
								duration:self.settings.duration, 
								wait:false,
								link:'cancel'
							});					
							
							expandAnchor.on('click',function(event){ 
								event.stop();
								var opacity = details.css('opacity');
								if(opacity > 0){
									effect.start({'opacity':0}).chain(function(){
										details.css('display','none')});
								}
								else{
									details.css('display','block');
									effect.start({'opacity':1});
								}
							});
							
							resultContainer.on('mouseover',function(){
								resultContainer.addClass('LiveSearchResultHover');
								mainAnchor.addClass('hovered');
							});
							resultContainer.on('mouseout',function(){
								resultContainer.removeClass('LiveSearchResultHover');
								mainAnchor.removeClass('hovered');
								resultContainer.addClass('LiveSearchResult');									  
							});			
						}.bind(this));
					},
					
					setNavigation: function(pages){
						
						
						self = this;
						
						if( pages > this.currentPage ){
							var next = new Element('a',{
								'href':'#',
								'class':'next',
								'html':'next'
							}).inject(this.searchResults);
							next.on('click',function(event){
								event.stop();						   
								this.currentPage+=1;
								this.navigate = true;
								this.request();
							}.bind(this));
						}
						if( this.currentPage > 1 ){
							var prev = new Element('a',{
								'href':'#',
								'class':'back',
								'html':'back'
							}).inject(this.searchResults);
							prev.on('click',function(event){
								event.stop();	
								this.currentPage-=1;
								this.navigate = true;
								this.request();
							}.bind(this));
						}
					},
					
					createURL: function(){
						
						
						self = this;
						
						return self.settings.resultFeed+
							   '?search='+$(self.settings.inputId).value+
							   '&page='+this.currentPage;
					},
					
					toggleSearch: function(showResults){
						
						self = this;
						
						var opacity = showResults ? 1 : 0;
						/*input position*/		
						if(showResults || this.navigate){
							this.searchResultsContainer.css({'top':$(self.settings.inputId).css('top') + self.settings.topDistance ,'left':$(self.settings.inputId).css('left')});
						}
						else{
							this.searchResultsContainer.css({'top':-1000 ,'left':-1000});
							this.currentPage = 1;
						}		
						if(!this.navigate)
							this.fadeSearch.start({'opacity':opacity});			
						
						this.navigate = false;		
					}
		});


		$.fn[ pluginName ] = function ( options ) {
				this.each(function() {
						if ( !$.data( this, "plugin_" + pluginName ) ) {
								$.data( this, "plugin_" + pluginName, new Plugin( this, options ) );
						}
				});

				// chain jQuery functions
				return this;
		};

})( jQuery, window, document );


jQuery(document ).ready(function() {
		
		
	jQuery('#defaultfeedLiveSearch').YJLiveSearch({
		  inputId:'#defaultfeedLiveSearch', 
		  inputCopy:'#defaultfeed',
		  resultFeed:'http://localhost/Development/V5/modules/mod_yj_live_search/customfeeds/feed.php', 
		  noResultsMessage:'Sorry, no results for&nbsp;', 
		  topDistance:35, 
		  duration:500,
		  minLenght:3,
		  maxLenght:10,
		  minCharTxt1:'Minimum&nbsp;',
		  minCharTxt2:'&nbsp;characters required'

	  });
	  

	  
});